import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrHomeworkanswerpage {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  HomeworkId!: IType<number, bigint>;
  StudentId!: IType<number, bigint>;
  PageId!: IType<number, bigint>;
  DotPageNum!: number;
  PageResultUrl?: string;
  Type!: number;
  LastTag!: IType<number, bigint>;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
  PageDotResultUrl?: string;
}

export const IcrHomeworkanswerpageSchema = defineEntity({
  class: IcrHomeworkanswerpage,
  comment: '作业回答',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    HomeworkId: p.bigint().name('HomeworkId').columnType('bigint').comment('作业id').index('idx_ICR_HomeworkAnswerPage_01'),
    StudentId: p.bigint().name('StudentId').columnType('bigint').comment('答题人id').index('idx_ICR_HomeworkAnswerPage_02'),
    PageId: p.bigint().name('PageId').columnType('bigint').comment('页Id和联动'),
    DotPageNum: p.integer().name('DotPageNum').comment('点阵页序号'),
    PageResultUrl: p.string().name('PageResultUrl').nullable().comment('页结果图片地址'),
    Type: p.integer().name('Type').comment('1:回答 2:草稿'),
    LastTag: p.bigint().name('LastTag').columnType('bigint').comment('最后修改标记'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
    PageDotResultUrl: p.string().name('PageDotResultUrl').nullable().comment('页结果点阵图片地址'),
  },
});
